## obs-studio-dmo 29.1.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

set(obs-websocket_VERSION 5.2.2)
set(OBS_WEBSOCKET_RPC_VERSION 1)

option(ENABLE_WEBSOCKET "Enable building OBS with websocket plugin" ON)
if(NOT ENABLE_WEBSOCKET)
  target_disable(obs-websocket)
  return()
endif()

# Submodule deps check
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/deps/qr/cpp/QrCode.hpp")
  message(FATAL_ERROR "obs-websocket submodule deps not available.")
endif()

# Find Qt
find_qt(COMPONENTS Core Widgets Svg Network)

# Find nlohmann JSON
find_package(nlohmann_json 3 REQUIRED)

# Find WebSocket++
find_package(Websocketpp 0.8 REQUIRED)

# Find Asio
find_package(Asio 1.12.1 REQUIRED)

add_library(obs-websocket MODULE)
add_library(OBS::websocket ALIAS obs-websocket)

target_sources(obs-websocket PRIVATE)

target_sources(
  obs-websocket
  PRIVATE src/obs-websocket.cpp
          src/obs-websocket.h
          src/Config.cpp
          src/Config.h
          lib/obs-websocket-api.h
          src/forms/ConnectInfo.cpp
          src/forms/ConnectInfo.h
          src/forms/resources.qrc
          src/forms/SettingsDialog.cpp
          src/forms/SettingsDialog.h
          src/WebSocketApi.cpp
          src/WebSocketApi.h)

target_sources(
  obs-websocket
  PRIVATE src/websocketserver/WebSocketServer.cpp
          src/websocketserver/WebSocketServer_Protocol.cpp
          src/websocketserver/WebSocketServer.h
          src/websocketserver/rpc/WebSocketSession.cpp
          src/websocketserver/rpc/WebSocketSession.h
          src/websocketserver/types/WebSocketCloseCode.h
          src/websocketserver/types/WebSocketOpCode.h)

target_sources(
  obs-websocket
  PRIVATE src/eventhandler/EventHandler.cpp
          src/eventhandler/EventHandler.h
          src/eventhandler/EventHandler_Config.cpp
          src/eventhandler/EventHandler_General.cpp
          src/eventhandler/EventHandler_Filters.cpp
          src/eventhandler/EventHandler_Inputs.cpp
          src/eventhandler/EventHandler_MediaInputs.cpp
          src/eventhandler/EventHandler_Outputs.cpp
          src/eventhandler/EventHandler_Scenes.cpp
          src/eventhandler/EventHandler_SceneItems.cpp
          src/eventhandler/EventHandler_Transitions.cpp
          src/eventhandler/EventHandler_Ui.cpp
          src/eventhandler/types/EventSubscription.h)

target_sources(
  obs-websocket
  PRIVATE src/requesthandler/RequestBatchHandler.cpp
          src/requesthandler/RequestBatchHandler.h
          src/requesthandler/RequestHandler.cpp
          src/requesthandler/RequestHandler.h
          src/requesthandler/RequestHandler_Config.cpp
          src/requesthandler/RequestHandler_Filters.cpp
          src/requesthandler/RequestHandler_General.cpp
          src/requesthandler/RequestHandler_Inputs.cpp
          src/requesthandler/RequestHandler_MediaInputs.cpp
          src/requesthandler/RequestHandler_Outputs.cpp
          src/requesthandler/RequestHandler_Sources.cpp
          src/requesthandler/RequestHandler_Record.cpp
          src/requesthandler/RequestHandler_Scenes.cpp
          src/requesthandler/RequestHandler_SceneItems.cpp
          src/requesthandler/RequestHandler_Stream.cpp
          src/requesthandler/RequestHandler_Transitions.cpp
          src/requesthandler/RequestHandler_Ui.cpp
          src/requesthandler/rpc/Request.cpp
          src/requesthandler/rpc/Request.h
          src/requesthandler/rpc/RequestBatchRequest.cpp
          src/requesthandler/rpc/RequestBatchRequest.h
          src/requesthandler/rpc/RequestResult.cpp
          src/requesthandler/rpc/RequestResult.h
          src/requesthandler/types/RequestStatus.h
          src/requesthandler/types/RequestBatchExecutionType.h)

target_sources(
  obs-websocket
  PRIVATE src/utils/Compat.cpp
          src/utils/Compat.h
          src/utils/Crypto.cpp
          src/utils/Crypto.h
          src/utils/Json.cpp
          src/utils/Json.h
          src/utils/Obs.cpp
          src/utils/Obs.h
          src/utils/Obs_ActionHelper.cpp
          src/utils/Obs_ArrayHelper.cpp
          src/utils/Obs_NumberHelper.cpp
          src/utils/Obs_ObjectHelper.cpp
          src/utils/Obs_StringHelper.cpp
          src/utils/Obs_SearchHelper.cpp
          src/utils/Obs_VolumeMeter.cpp
          src/utils/Obs_VolumeMeter.h
          src/utils/Obs_VolumeMeter_Helpers.h
          src/utils/Platform.cpp
          src/utils/Platform.h
          src/utils/Utils.h)

target_sources(obs-websocket PRIVATE deps/qr/cpp/QrCode.cpp deps/qr/cpp/QrCode.hpp)

configure_file(src/plugin-macros.h.in plugin-macros.generated.h)
target_sources(obs-websocket PRIVATE plugin-macros.generated.h)

target_compile_definitions(
  obs-websocket PRIVATE ASIO_STANDALONE $<$<BOOL:PLUGIN_TESTS>:PLUGIN_TESTS>
                        $<$<PLATFORM_ID:Windows>:_WEBSOCKETPP_CPP11_STL_> $<$<PLATFORM_ID:Windows>:_WIN32_WINNT=0x0603>)

target_compile_options(
  obs-websocket
  PRIVATE
    $<$<PLATFORM_ID:Windows>:/wd4267>
    $<$<PLATFORM_ID:Windows>:/wd4996>
    $<$<PLATFORM_ID:Darwin,Linux,FreeBSD>:-Wall>
    $<$<COMPILE_LANG_AND_ID:CXX,GNU,AppleClang,Clang>:-Wno-error=float-conversion;-Wno-error=shadow>
    $<$<COMPILE_LANG_AND_ID:CXX,GNU>:-Wno-error=format-overflow;-Wno-error=int-conversion;-Wno-error=comment>
    $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-error=null-pointer-subtraction;-Wno-error=deprecated-declarations;-Wno-error=implicit-int-conversion;-Wno-error=shorten-64-to-32>
)

target_link_libraries(
  obs-websocket
  PRIVATE OBS::libobs
          OBS::frontend-api
          Qt::Core
          Qt::Widgets
          Qt::Svg
          Qt::Network
          nlohmann_json::nlohmann_json
          Websocketpp::Websocketpp
          Asio::Asio)

set_target_properties_obs(
  obs-websocket
  PROPERTIES FOLDER plugins
             PREFIX ""
             AUTOMOC ON
             AUTOUIC ON
             AUTORCC ON)

if(OS_WINDOWS)
  set_property(
    TARGET obs-websocket
    APPEND
    PROPERTY AUTORCC_OPTIONS --format-version 1)
endif()

=== UI/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

add_subdirectory(obs-frontend-api)

option(ENABLE_UI "Enable building with UI (requires Qt)" ON)

if(NOT ENABLE_UI)
  target_disable_feature(obs "User Interface")
  return()
else()
  target_enable_feature(obs "User Interface")
endif()

find_package(FFmpeg REQUIRED COMPONENTS avcodec avutil avformat)
find_package(CURL REQUIRED)

if(NOT TARGET OBS::libff-util)
  add_subdirectory("${CMAKE_SOURCE_DIR}/deps/libff" "${CMAKE_BINARY_DIR}/deps/libff")
endif()

if(NOT TARGET OBS::json11)
  add_subdirectory("${CMAKE_SOURCE_DIR}/deps/json11" "${CMAKE_BINARY_DIR}/deps/json11")
endif()

add_executable(obs-studio)
add_executable(OBS::studio ALIAS obs-studio)

target_link_libraries(
  obs-studio
  PRIVATE CURL::libcurl
          FFmpeg::avcodec
          FFmpeg::avutil
          FFmpeg::avformat
          OBS::libobs
          OBS::frontend-api
          OBS::libff-util
          OBS::json11)

include(cmake/ui-qt.cmake)
include(cmake/ui-elements.cmake)
include(cmake/ui-windows.cmake)
include(cmake/feature-importers.cmake)
include(cmake/feature-browserpanels.cmake)

if(NOT OAUTH_BASE_URL)
  set(OAUTH_BASE_URL
      "https://auth.obsproject.com/"
      CACHE STRING "Default OAuth base URL")

  mark_as_advanced(OAUTH_BASE_URL)
endif()
include(cmake/feature-twitch.cmake)
include(cmake/feature-restream.cmake)
include(cmake/feature-youtube.cmake)
include(cmake/feature-sparkle.cmake)
include(cmake/feature-whatsnew.cmake)

add_subdirectory(frontend-plugins)

configure_file(ui-config.h.in ui-config.h)

target_sources(
  obs-studio
  PRIVATE # cmake-format: sortable
          api-interface.cpp
          auth-base.cpp
          auth-base.hpp
          auth-listener.cpp
          auth-listener.hpp
          auth-oauth.cpp
          auth-oauth.hpp
          display-helpers.hpp
          multiview.cpp
          multiview.hpp
          obf.c
          obf.h
          obs-app.cpp
          obs-app.hpp
          obs-proxy-style.cpp
          obs-proxy-style.hpp
          platform.hpp
          qt-display.cpp
          qt-display.hpp
          qt-wrappers.cpp
          qt-wrappers.hpp
          ui-config.h
          ui-validation.cpp
          ui-validation.hpp)

if(OS_WINDOWS)
  include(cmake/os-windows.cmake)
elseif(OS_MACOS)
  include(cmake/os-macos.cmake)
elseif(OS_LINUX)
  include(cmake/os-linux.cmake)
elseif(OS_FREEBSD)
  include(cmake/os-freebsd.cmake)
endif()

foreach(graphics_library IN ITEMS opengl metal d3d11)
  string(TOUPPER ${graphics_library} graphics_library_U)
  if(TARGET OBS::libobs-${graphics_library})
    target_compile_definitions(obs-studio
                               PRIVATE DL_${graphics_library_U}="$<TARGET_FILE_NAME:OBS::libobs-${graphics_library}>")
  else()
    target_compile_definitions(obs-studio PRIVATE DL_${graphics_library_U}="")
  endif()
endforeach()

set_target_properties_obs(obs-studio PROPERTIES FOLDER frontend OUTPUT_NAME obs)

=== amf-test/CMakeLists.txt ===
# A Plugin that integrates the AMD AMF encoder into OBS Studio
# Copyright (C) 2016 - 2017 Michael Fabian Dirks
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

cmake_minimum_required(VERSION 3.1.0)
PROJECT(enc-amf-test)

################################################################################
# CMake / Compiler
################################################################################

# All Warnings, Extra Warnings, Pedantic
if(MSVC)
	# Force to always compile with W4
	if(CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
		string(REGEX REPLACE "/W[0-4]" "/W4" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
	else()
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
	endif()

	add_definitions(-D_CRT_SECURE_NO_WARNINGS)
elseif(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
	# Update if necessary
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-long-long -pedantic")
endif()

# Detect Architecture (Bitness)
math(EXPR BITS "8*${CMAKE_SIZEOF_VOID_P}")

add_definitions(-DLITE_OBS)

################################################################################
# Configuration
################################################################################

# From Parent:
#   OBS_STUDIO_DIR
#   ${PropertyPrefix}OBS_NATIVE
#   ${PropertyPrefix}OBS_PACKAGE
#   AMF_SDK_DIR

IF(WIN32)
	# windows.h
	add_definitions(-DWIN32_LEAN_AND_MEAN)
	add_definitions(-DNOGPICAPMASKS)
	add_definitions(-DNOVIRTUALKEYCODES)
	#add_definitions(-DNOWINMESSAGES)
	add_definitions(-DNOWINSTYLES)
	add_definitions(-DNOSYSMETRICS)
	add_definitions(-DNOMENUS)
	add_definitions(-DNOICONS)
	add_definitions(-DNOKEYSTATES)
	add_definitions(-DNOSYSCOMMANDS)
	add_definitions(-DNORASTEROPS)
	add_definitions(-DNOSHOWWINDOW)
	add_definitions(-DNOATOM)
	add_definitions(-DNOCLIPBOARD)
	add_definitions(-DNOCOLOR)
	add_definitions(-DNOCTLMGR)
	add_definitions(-DNODRAWTEXT)
	#add_definitions(-DNOGDI)
	add_definitions(-DNOKERNEL)
	#add_definitions(-DNOUSER)
	#add_definitions(-DNONLS)
	add_definitions(-DNOMB)
	add_definitions(-DNOMEMMGR)
	add_definitions(-DNOMETAFILE)
	add_definitions(-DNOMINMAX)
	#add_definitions(-DNOMSG)
	add_definitions(-DNOOPENFILE)
	add_definitions(-DNOSCROLL)
	add_definitions(-DNOSERVICE)
	add_definitions(-DNOSOUND)
	#add_definitions(-DNOTEXTMETRIC)
	add_definitions(-DNOWH)
	add_definitions(-DNOWINOFFSETS)
	add_definitions(-DNOCOMM)
	add_definitions(-DNOKANJI)
	add_definitions(-DNOHELP)
	add_definitions(-DNOPROFILER)
	add_definitions(-DNODEFERWINDOWPOS)
	add_definitions(-DNOMCX)
	add_definitions(-DNOIME)
	add_definitions(-DNOMDI)
	add_definitions(-DNOINOUT)
ENDIF()


################################################################################
# Dependencies
################################################################################

# Project
add_executable(enc-amf-test
	"${PROJECT_SOURCE_DIR}/main.cpp"
	"${enc-amf_SOURCE_DIR}/source/amf.cpp"
	"${enc-amf_SOURCE_DIR}/source/amf-capabilities.cpp"
	"${enc-amf_SOURCE_DIR}/source/amf-encoder.cpp"
	"${enc-amf_SOURCE_DIR}/source/amf-encoder-h264.cpp"
	"${enc-amf_SOURCE_DIR}/source/amf-encoder-h265.cpp"
	"${enc-amf_SOURCE_DIR}/source/api-base.cpp"
	"${enc-amf_SOURCE_DIR}/source/api-d3d9.cpp"
	"${enc-amf_SOURCE_DIR}/source/api-d3d11.cpp"
	"${enc-amf_SOURCE_DIR}/source/utility.cpp"
	"${enc-amf_SOURCE_DIR}/include/amf.hpp"
	"${enc-amf_SOURCE_DIR}/include/amf-capabilities.hpp"
	"${enc-amf_SOURCE_DIR}/include/amf-encoder.hpp"
	"${enc-amf_SOURCE_DIR}/include/amf-encoder-h264.hpp"
	"${enc-amf_SOURCE_DIR}/include/amf-encoder-h265.hpp"
	"${enc-amf_SOURCE_DIR}/include/api-base.hpp"
	"${enc-amf_SOURCE_DIR}/include/api-d3d9.hpp"
	"${enc-amf_SOURCE_DIR}/include/api-d3d11.hpp"
	"${enc-amf_SOURCE_DIR}/include/utility.hpp"
)
target_include_directories(enc-amf-test
	PUBLIC
		"${PROJECT_SOURCE_DIR}"
		"${enc-amf_SOURCE_DIR}/include"
		"${enc-amf_BINARY_DIR}/include"
		"${enc-amf_SOURCE_DIR}/source"
		"${enc-amf_SOURCE_DIR}/AMF/amf/public/include"
)
IF(${PropertyPrefix}OBS_NATIVE)
	target_include_directories(enc-amf-test
		PUBLIC
	)
ELSEIF(${PropertyPrefix}OBS_PACKAGE)
	target_include_directories(enc-amf-test
		PUBLIC
	)
ELSE()
	target_include_directories(enc-amf-test
		PUBLIC
	)
ENDIF()

IF(WIN32)
	target_link_libraries(enc-amf-test
		version
		winmm
	)
ENDIF()

set_target_properties(enc-amf-test
	PROPERTIES
		OUTPUT_NAME "enc-amf-test${BITS}")

if(${PropertyPrefix}OBS_NATIVE)
	install_obs_datatarget(enc-amf-test "obs-plugins/enc-amf")
	Set_Target_Properties(enc-amf-test PROPERTIES FOLDER "plugins/enc-amf")
else()
	INSTALL(TARGETS enc-amf-test
		RUNTIME DESTINATION "./data/obs-plugins/enc-amf/" COMPONENT Runtime
		LIBRARY DESTINATION "./data/obs-plugins/enc-amf/" COMPONENT Runtime
	)
	INSTALL(FILES $<TARGET_PDB_FILE:enc-amf-test> DESTINATION "./data/obs-plugins/enc-amf/" OPTIONAL)
endif()

=== deps/CMakeLists.txt ===
if(OBS_CMAKE_VERSION VERSION_GREATER_EQUAL 3.0.0)
  return()
endif()

if(OS_WINDOWS)
  if(NOT MINGW)
    add_subdirectory(w32-pthreads)
  endif()
  add_subdirectory(ipc-util)
endif()

add_subdirectory(blake2)
add_subdirectory(glad)
add_subdirectory(media-playback)
add_subdirectory(file-updater)
add_subdirectory(obs-scripting)
add_subdirectory(opts-parser)
add_subdirectory(libcaption)
add_subdirectory(uthash)

# Use bundled jansson version as fallback
find_package(Jansson 2.5 QUIET)
if(NOT TARGET Jansson::Jansson)
  obs_status(STATUS "Jansson >=2.5 not found, building bundled version.")

  add_subdirectory(jansson)
  add_library(Jansson::Jansson ALIAS jansson)
else()
  obs_status(STATUS "Using system Jansson library.")
endif()

=== libobs-d3d11/CMakeLists.txt ===
project(libobs-d3d11)

add_library(libobs-d3d11 MODULE)
add_library(OBS::libobs-d3d11 ALIAS libobs-d3d11)

target_sources(
  libobs-d3d11
  PRIVATE d3d11-indexbuffer.cpp
          d3d11-samplerstate.cpp
          d3d11-shader.cpp
          d3d11-shaderprocessor.cpp
          d3d11-shaderprocessor.hpp
          d3d11-stagesurf.cpp
          d3d11-subsystem.cpp
          d3d11-subsystem.hpp
          d3d11-texture2d.cpp
          d3d11-texture3d.cpp
          d3d11-vertexbuffer.cpp
          d3d11-duplicator.cpp
          d3d11-rebuild.cpp
          d3d11-zstencilbuffer.cpp)

set(MODULE_DESCRIPTION "OBS Library D3D11 wrapper")
configure_file(${CMAKE_SOURCE_DIR}/cmake/bundle/windows/obs-module.rc.in libobs-d3d11.rc)

target_include_directories(libobs-d3d11 PRIVATE ${CMAKE_CURRENT_BINARY_DIR})

target_sources(libobs-d3d11 PRIVATE libobs-d3d11.rc)

target_compile_features(libobs-d3d11 PRIVATE cxx_std_17)

target_compile_definitions(libobs-d3d11 PRIVATE UNICODE _UNICODE _CRT_SECURE_NO_WARNINGS _CRT_NONSTDC_NO_WARNINGS)

if(NOT DEFINED GPU_PRIORITY_VAL
   OR "x${GPU_PRIORITY_VAL}x" STREQUAL "xx"
   OR "${GPU_PRIORITY_VAL}" STREQUAL "0")
  target_compile_definitions(libobs-d3d11 PRIVATE USE_GPU_PRIORITY=FALSE GPU_PRIORITY_VAL=0)
else()
  target_compile_definitions(libobs-d3d11 PRIVATE USE_GPU_PRIORITY=TRUE GPU_PRIORITY_VAL=${GPU_PRIORITY_VAL})
endif()

target_link_libraries(libobs-d3d11 PRIVATE OBS::libobs d3d9 d3d11 dxgi shcore)

set_target_properties(
  libobs-d3d11
  PROPERTIES OUTPUT_NAME libobs-d3d11
             FOLDER "core"
             PREFIX "")

setup_binary_target(libobs-d3d11)

=== libobs-winrt/CMakeLists.txt ===
project(libobs-winrt)

add_library(libobs-winrt MODULE)
add_library(OBS::libobs-winrt ALIAS libobs-winrt)

target_sources(libobs-winrt PRIVATE winrt-capture.cpp winrt-capture.h winrt-dispatch.cpp winrt-dispatch.h)

target_precompile_headers(
  libobs-winrt
  PRIVATE
  [["../libobs/util/windows/ComPtr.hpp"]]
  <obs-module.h>
  <d3d11.h>
  <DispatcherQueue.h>
  <dwmapi.h>
  <Windows.Graphics.Capture.Interop.h>
  <winrt/Windows.Foundation.Metadata.h>
  <winrt/Windows.Graphics.Capture.h>
  <winrt/Windows.System.h>)

target_link_libraries(libobs-winrt PRIVATE OBS::libobs Dwmapi windowsapp)

target_compile_features(libobs-winrt PRIVATE cxx_std_17)

set_target_properties(
  libobs-winrt
  PROPERTIES OUTPUT_NAME libobs-winrt
             FOLDER "core"
             PREFIX "")

setup_binary_target(libobs-winrt)

=== deps/file-updater/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

find_package(CURL REQUIRED)

add_library(file-updater INTERFACE)
add_library(OBS::file-updater ALIAS file-updater)

target_sources(file-updater INTERFACE file-updater/file-updater.c file-updater/file-updater.h)

target_link_libraries(file-updater INTERFACE CURL::libcurl $<$<PLATFORM_ID:Windows>:OBS::w32-pthreads>)

target_include_directories(file-updater INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

=== deps/jansson/CMakeLists.txt ===
# Notes:
#
# Author: Paul Harris, June 2012 Additions: Joakim Soderberg, Febuary 2013
#
# Supports: building static/shared, release/debug/etc, can also build html docs
# and some of the tests. Note that its designed for out-of-tree builds, so it
# will not pollute your source tree.
#
# TODO 1: Finish implementing tests. api tests are working, but the valgrind
# variants are not flagging problems.
#
# TODO 2: There is a check_exports script that would try and incorporate.
#
# TODO 3: Consolidate version numbers, currently the version number is written
# into: * cmake (here) * autotools (the configure) * source code header files.
# Should not be written directly into header files, autotools/cmake can do that
# job.
#
# Brief intro on how to use cmake: > mkdir build (somewhere - we do out-of-tree
# builds) > use cmake, ccmake, or cmake-gui to configure the project. for linux,
# you can only choose one variant: release,debug,etc... and static or shared. >>
# example: >> cd build >> ccmake -i ../path_to_jansson_dir >>  inside, configure
# your options. press C until there are no lines with * next to them. >>  note,
# I like to configure the 'install' path to ../install, so I get self-contained
# clean installs I can point other projects to. >>  press G to 'generate' the
# project files. >> make (to build the project) >> make install >> make test (to
# run the tests, if you enabled them)
#
# Brief description on how it works: There is a small heirachy of CMakeLists.txt
# files which define how the project is built. Header file detection etc is
# done, and the results are written into config.h and jansson_config.h, which
# are generated from the corresponding config.h.cmake and jansson_config.h.cmake
# template files. The generated header files end up in the build directory - not
# in the source directory. The rest is down to the usual make process.

cmake_minimum_required(VERSION 2.8.12)
# required for exports? cmake_minimum_required (VERSION 2.8.6)
project(jansson C)

# Options
option(JANSSON_BUILD_SHARED_LIBS "Build shared libraries." OFF)
option(USE_URANDOM "Use /dev/urandom to seed the hash function." ON)
option(USE_WINDOWS_CRYPTOAPI "Use CryptGenRandom to seed the hash function." ON)

if(MSVC)
  # This option must match the settings used in your program, in particular if
  # you are linking statically
  option(JANSSON_STATIC_CRT "Link the static CRT libraries" ON)
endif()

# Disabled by OBS
option(JANSSON_EXAMPLES "Compile example applications" OFF)

if(UNIX)
  option(
    JANSSON_COVERAGE
    "(GCC Only! Requires gcov/lcov to be installed). Include target for doing coverage analysis for the test suite. Note that -DCMAKE_BUILD_TYPE=Debug must be set"
    OFF)
  option(JANSSON_COVERALLS "Generate coverage info for Coveralls" OFF)
  option(JANSSON_COVERALLS_UPLOAD
         "Upload coverage info to Coveralls (Only works via Travis)" ON)
endif()

# Set some nicer output dirs.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(JANSSON_TEMP_DIR ${PROJECT_BINARY_DIR}/tmp)

# Give the debug version a different postfix for windows, so both the debug and
# release version can be built in the same build-tree on Windows (MSVC).
if(WIN32)
  set(CMAKE_DEBUG_POSTFIX "_d")
endif(WIN32)

# This is how I thought it should go set (JANSSON_VERSION "2.3.1") set
# (JANSSON_SOVERSION 2)

set(JANSSON_DISPLAY_VERSION "2.9")

# This is what is required to match the same numbers as automake's
set(JANSSON_VERSION "4.9.0")
set(JANSSON_SOVERSION 4)

# for CheckFunctionKeywords
set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckFunctionKeywords)
include(CheckIncludeFiles)
include(CheckTypeSize)

if(MSVC)
  # Turn off Microsofts "security" warnings.
  add_definitions("/W3 /D_CRT_SECURE_NO_WARNINGS /wd4005 /wd4996 /nologo")

  # Disabled by OBS, options already set by top level CMakeLists
  if(FALSE)
    if(JANSSON_STATIC_CRT)
      set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} /MT")
      set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} /MTd")
    endif()
  endif()

endif()

if(NOT WIN32 AND NOT APPLE)
  add_definitions("-fPIC")
endif()

message("C compiler: ${CMAKE_C_COMPILER_ID}")

# Coverage only works with GCC for a debug build.
if(JANSSON_COVERALLS)
  set(JANSSON_COVERAGE ON)
endif()

if(JANSSON_COVERAGE)
  include(CodeCoverage)
  include(Coveralls)

  # This adds coverage arguments to gcc/clang.
  coveralls_turn_on_coverage()
endif()

check_include_files(endian.h HAVE_ENDIAN_H)
check_include_files(fcntl.h HAVE_FCNTL_H)
check_include_files(sched.h HAVE_SCHED_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(sys/param.h HAVE_SYS_PARAM_H)
check_include_files(sys/stat.h HAVE_SYS_STAT_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(sys/time.h HAVE_SYS_TYPES_H)

check_function_exists(close HAVE_CLOSE)
check_function_exists(getpid HAVE_GETPID)
check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists(open HAVE_OPEN)
check_function_exists(read HAVE_READ)
check_function_exists(sched_yield HAVE_SCHED_YIELD)

# Check for the int-type includes
check_include_files(stdint.h HAVE_STDINT_H)

# Check our 64 bit integer sizes
check_type_size(__int64 __INT64)
check_type_size(int64_t INT64_T)
check_type_size("long long" LONG_LONG_INT)

# Check our 32 bit integer sizes
check_type_size(int32_t INT32_T)
check_type_size(__int32 __INT32)
check_type_size("long" LONG_INT)
check_type_size("int" INT)
if(HAVE_INT32_T)
  set(JSON_INT32 int32_t)
elseif(HAVE___INT32)
  set(JSON_INT32 __int32)
elseif(HAVE_LONG_INT AND (${LONG_INT} EQUAL 4))
  set(JSON_INT32 long)
elseif(HAVE_INT AND (${INT} EQUAL 4))
  set(JSON_INT32 int)
else()
  message(FATAL_ERROR "Could not detect a valid 32-bit integer type")
endif()

check_type_size("unsigned long" UNSIGNED_LONG_INT)
check_type_size("unsigned int" UNSIGNED_INT)
check_type_size("unsigned short" UNSIGNED_SHORT)

check_type_size(uint32_t UINT32_T)
check_type_size(__uint32 __UINT32)
if(HAVE_UINT32_T)
  set(JSON_UINT32 uint32_t)
elseif(HAVE___UINT32)
  set(JSON_UINT32 __uint32)
elseif(HAVE_UNSIGNED_LONG_INT AND (${UNSIGNED_LONG_INT} EQUAL 4))
  set(JSON_UINT32 "unsigned long")
elseif(HAVE_UNSIGNED_INT AND (${UNSIGNED_INT} EQUAL 4))
  set(JSON_UINT32 "unsigned int")
else()
  message(FATAL_ERROR "Could not detect a valid unsigned 32-bit integer type")
endif()

check_type_size(uint16_t UINT16_T)
check_type_size(__uint16 __UINT16)
if(HAVE_UINT16_T)
  set(JSON_UINT16 uint16_t)
elseif(HAVE___UINT16)
  set(JSON_UINT16 __uint16)
elseif(HAVE_UNSIGNED_INT AND (${UNSIGNED_INT} EQUAL 2))
  set(JSON_UINT16 "unsigned int")
elseif(HAVE_UNSIGNED_SHORT AND (${UNSIGNED_SHORT} EQUAL 2))
  set(JSON_UINT16 "unsigned short")
else()
  message(FATAL_ERROR "Could not detect a valid unsigned 16-bit integer type")
endif()

check_type_size(uint8_t UINT8_T)
check_type_size(__uint8 __UINT8)
if(HAVE_UINT8_T)
  set(JSON_UINT8 uint8_t)
elseif(HAVE___UINT8)
  set(JSON_UINT8 __uint8)
else()
  set(JSON_UINT8 "unsigned char")
endif()

# Check for ssize_t and SSIZE_T existance.
check_type_size(ssize_t SSIZE_T)
check_type_size(SSIZE_T UPPERCASE_SSIZE_T)
if(NOT HAVE_SSIZE_T)
  if(HAVE_UPPERCASE_SSIZE_T)
    set(JSON_SSIZE SSIZE_T)
  else()
    set(JSON_SSIZE int)
  endif()
endif()
set(CMAKE_EXTRA_INCLUDE_FILES "")

# Check for all the variants of strtoll
check_function_exists(strtoll HAVE_STRTOLL)
check_function_exists(strtoq HAVE_STRTOQ)
check_function_exists(_strtoi64 HAVE__STRTOI64)

# Figure out what variant we should use
if(HAVE_STRTOLL)
  set(JSON_STRTOINT strtoll)
elseif(HAVE_STRTOQ)
  set(JSON_STRTOINT strtoq)
elseif(HAVE__STRTOI64)
  set(JSON_STRTOINT _strtoi64)
else()
  # fallback to strtol (32 bit) this will set all the required variables
  set(JSON_STRTOINT strtol)
  set(JSON_INT_T long)
  set(JSON_INTEGER_FORMAT "\"ld\"")
endif()

# if we haven't defined JSON_INT_T, then we have a 64 bit conversion function.
# detect what to use for the 64 bit type. Note: I will prefer long long if I can
# get it, as that is what the automake system aimed for.
if(NOT DEFINED JSON_INT_T)
  if(HAVE_LONG_LONG_INT AND ((${LONG_LONG_INT}) EQUAL 8))
    set(JSON_INT_T "long long")
  elseif(HAVE_INT64_T)
    set(JSON_INT_T int64_t)
  elseif(HAVE___INT64)
    set(JSON_INT_T __int64)
  else()
    message(
      FATAL_ERROR
        "Could not detect 64 bit type, although I detected the strtoll equivalent"
    )
  endif()

  # Apparently, Borland BCC and MSVC wants I64d, Borland BCC could also accept
  # LD and gcc wants ldd, I am not sure what cygwin will want, so I will assume
  # I64d

  if(WIN32) # matches both msvc and cygwin
    set(JSON_INTEGER_FORMAT "\"I64d\"")
  else()
    set(JSON_INTEGER_FORMAT "\"lld\"")
  endif()
endif()

# If locale.h and localeconv() are available, define to 1, otherwise to 0.
check_include_files(locale.h HAVE_LOCALE_H)
check_function_exists(localeconv HAVE_LOCALECONV)

if(HAVE_LOCALECONV AND HAVE_LOCALE_H)
  set(JSON_HAVE_LOCALECONV 1)
else()
  set(JSON_HAVE_LOCALECONV 0)
endif()

# check if we have setlocale
check_function_exists(setlocale HAVE_SETLOCALE)

# Check what the inline keyword is. Note that the original JSON_INLINE was
# always set to just 'inline', so this goes further.
check_function_keywords("inline")
check_function_keywords("__inline")
check_function_keywords("__inline__")

if(HAVE_INLINE)
  set(JSON_INLINE inline)
elseif(HAVE___INLINE)
  set(JSON_INLINE __inline)
elseif(HAVE___INLINE__)
  set(JSON_INLINE __inline__)
else()
  # no inline on this platform
  set(JSON_INLINE)
endif()

check_c_source_compiles(
  "int main() { unsigned long val; __sync_bool_compare_and_swap(&val, 0, 1); return 0; } "
  HAVE_SYNC_BUILTINS)
check_c_source_compiles(
  "int main() { char l; unsigned long v; __atomic_test_and_set(&l, __ATOMIC_RELAXED); __atomic_store_n(&v, 1, __ATOMIC_RELEASE); __atomic_load_n(&v, __ATOMIC_ACQUIRE); return 0; }"
  HAVE_ATOMIC_BUILTINS)

set(JANSSON_INITIAL_HASHTABLE_ORDER
    3
    CACHE
      STRING
      "Number of buckets new object hashtables contain is 2 raised to this power. The default is 3, so empty hashtables contain 2^3 = 8 buckets."
)

# configure the public config file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/jansson_config.h.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/include/jansson_config.h)

# Copy the jansson.h file to the public include folder
file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson.h
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/include/)

add_definitions(-DJANSSON_USING_CMAKE)

# configure the private config file
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/jansson_private_config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/private_include/jansson_private_config.h)

# and tell the source code to include it
add_definitions(-DHAVE_CONFIG_H)

include_directories(${CMAKE_CURRENT_BINARY_DIR}/include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/private_include)

# Add the lib sources.
file(GLOB JANSSON_SRC src/*.c)

set(JANSSON_HDR_PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/src/hashtable.h
    ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson_private.h
    ${CMAKE_CURRENT_SOURCE_DIR}/src/strbuffer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/src/utf.h
    ${CMAKE_CURRENT_BINARY_DIR}/private_include/jansson_private_config.h)

set(JANSSON_HDR_PUBLIC ${CMAKE_CURRENT_BINARY_DIR}/include/jansson_config.h
                       ${CMAKE_CURRENT_SOURCE_DIR}/src/jansson.h)

source_group("Library Sources" FILES ${JANSSON_SRC})
source_group("Library Private Headers" FILES ${JANSSON_HDR_PRIVATE})
source_group("Library Public Headers" FILES ${JANSSON_HDR_PUBLIC})

if(JANSSON_BUILD_SHARED_LIBS)
  add_library(jansson SHARED ${JANSSON_SRC} ${JANSSON_HDR_PRIVATE}
                             ${JANSSON_HDR_PUBLIC} src/jansson.def)

  set_target_properties(jansson PROPERTIES VERSION ${JANSSON_VERSION}

=== deps/json11/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

add_library(json11 INTERFACE)
add_library(OBS::json11 ALIAS json11)

target_include_directories(json11 INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

target_sources(json11 INTERFACE json11.cpp json11.hpp)

=== deps/libff/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

add_library(libff-util INTERFACE)
add_library(OBS::libff-util ALIAS libff-util)

target_sources(libff-util INTERFACE libff/ff-util.c libff/ff-util.h)
target_include_directories(libff-util INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")

if(OS_WINDOWS)
  set_property(
    SOURCE libff/ff-util.c
    APPEND
    PROPERTY COMPILE_FLAGS -Dinline=__inline)
endif()

=== deps/media-playback/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

find_package(FFmpeg REQUIRED COMPONENTS avcodec avdevice avutil avformat)

add_library(media-playback INTERFACE)
add_library(OBS::media-playback ALIAS media-playback)

target_sources(
  media-playback
  INTERFACE media-playback/media.c
            media-playback/media.h
            media-playback/cache.c
            media-playback/cache.h
            media-playback/decode.c
            media-playback/decode.h
            media-playback/media-playback.c
            media-playback/media-playback.h
            media-playback/closest-format.h)

target_include_directories(media-playback INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}")
target_compile_options(media-playback INTERFACE ${ARCH_SIMD_FLAGS})
target_compile_definitions(media-playback INTERFACE ${ARCH_SIMD_DEFINES})

target_link_libraries(media-playback INTERFACE FFmpeg::avcodec FFmpeg::avdevice FFmpeg::avutil FFmpeg::avformat)

=== plugins/decklink/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...3.25)

legacy_check()

option(ENABLE_DECKLINK "Build OBS with Decklink support" ON)
if(NOT ENABLE_DECKLINK)
  target_disable(decklink)
  return()
endif()

add_library(decklink MODULE)
add_library(OBS::decklink ALIAS decklink)

add_library(decklink-sdk INTERFACE)
add_library(Decklink::SDK ALIAS decklink-sdk)

target_sources(
  decklink
  PRIVATE OBSVideoFrame.cpp
          OBSVideoFrame.h
          audio-repack.c
          audio-repack.h
          audio-repack.hpp
          const.h
          decklink-device.cpp
          decklink-device.hpp
          decklink-devices.cpp
          decklink-devices.hpp
          decklink-device-discovery.cpp
          decklink-device-discovery.hpp
          decklink-device-instance.cpp
          decklink-device-instance.hpp
          decklink-device-mode.cpp
          decklink-device-mode.hpp
          decklink-output.cpp
          decklink-source.cpp
          DecklinkBase.cpp
          DecklinkBase.h
          DecklinkInput.cpp
          DecklinkInput.hpp
          DecklinkOutput.cpp
          DecklinkOutput.hpp
          platform.hpp
          plugin-main.cpp
          util.cpp
          util.hpp)

target_link_libraries(decklink PRIVATE OBS::libobs OBS::caption Decklink::SDK)

if(OS_WINDOWS)
  configure_file(cmake/windows/obs-module.rc.in win-decklink.rc)
  target_compile_definitions(decklink PRIVATE NOMINMAX)
  target_sources(decklink PRIVATE win/platform.cpp win-decklink.rc)

  include(idlfilehelper)
  target_add_idl_files(decklink win/decklink-sdk/DeckLinkAPI.idl)

  target_sources(decklink-sdk INTERFACE win/decklink-sdk/DeckLinkAPIVersion.h)

elseif(OS_MACOS)
  find_library(COREFOUNDATION CoreFoundation)
  mark_as_advanced(COREFOUNDATION)

  target_sources(decklink PRIVATE mac/platform.cpp)
  target_link_libraries(decklink PRIVATE ${COREFOUNDATION})

  target_sources(
    decklink-sdk
    INTERFACE mac/decklink-sdk/DeckLinkAPIDispatch.cpp
              mac/decklink-sdk/DeckLinkAPI.h
              mac/decklink-sdk/DeckLinkAPIConfiguration.h
              mac/decklink-sdk/DeckLinkAPIDeckControl.h
              mac/decklink-sdk/DeckLinkAPIDiscovery.h
              mac/decklink-sdk/DeckLinkAPIModes.h
              mac/decklink-sdk/DeckLinkAPIStreaming.h
              mac/decklink-sdk/DeckLinkAPITypes.h
              mac/decklink-sdk/DeckLinkAPIVersion.h)
elseif(OS_LINUX OR OS_FREEBSD)
  target_sources(decklink PRIVATE linux/platform.cpp)

  target_sources(
    decklink-sdk
    INTERFACE linux/decklink-sdk/DeckLinkAPIDispatch.cpp
              linux/decklink-sdk/DeckLinkAPI.h
              linux/decklink-sdk/DeckLinkAPIConfiguration.h
              linux/decklink-sdk/DeckLinkAPIDeckControl.h
              linux/decklink-sdk/DeckLinkAPIDiscovery.h
              linux/decklink-sdk/DeckLinkAPIModes.h
              linux/decklink-sdk/DeckLinkAPITypes.h
              linux/decklink-sdk/DeckLinkAPIVersion.h
              linux/decklink-sdk/LinuxCOM.h)
endif()

set_target_properties_obs(decklink PROPERTIES FOLDER plugins/decklink PREFIX "")

=== debian/changelog ===
obs-studio-dmo (1:29.1.2-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 29 May 2023 01:31:51 +0200

obs-studio-dmo (1:29.1.1-dmo1) unstable; urgency=medium

  * New upstream bugfix release.
  * Update websocket to commit 57a9c19

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 09 May 2023 08:32:27 +0200

obs-studio-dmo (1:29.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 03 May 2023 07:32:53 +0200

obs-studio-dmo (1:29.0.2-dmo2) unstable; urgency=medium

  * Build with ffmpeg 6.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 02 Mar 2023 13:21:33 +0100

obs-studio-dmo (1:29.0.2-dmo1) unstable; urgency=medium

  * New upstream nugfix release.
  * Rename obs-amf tarball to obs-amd-encoder

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 04 Feb 2023 13:14:08 +0100

obs-studio-dmo (1:29.0.1-dmo1) unstable; urgency=medium

  * New upstream release.
  * Update amf plugin to 3b09f2a

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 03 Feb 2023 08:11:00 +0100

obs-studio-dmo (1:29.0.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 08 Jan 2023 01:25:21 +0100

obs-studio-dmo (1:28.1.2-dmo2) unstable; urgency=medium

  * Build with python 3.11

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 03 Jan 2023 08:33:51 +0100

obs-studio-dmo (1:28.1.2-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 06 Nov 2022 00:01:20 +0100

obs-studio-dmo (1:28.1.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 02 Nov 2022 07:51:00 +0100

obs-studio-dmo (1:28.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 01 Nov 2022 09:05:52 +0100

obs-studio-dmo (1:28.0.3-dmo1) unstable; urgency=medium

  * New upstream bugfix release.
  * Update obs-websocket to git commit b6e0888

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 02 Oct 2022 08:21:29 +0200

obs-studio-dmo (1:28.0.2-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 22 Sep 2022 23:20:22 +0200

obs-studio-dmo (1:28.0.1-dmo2) unstable; urgency=medium

  * Add Replaces/Breaks obs-websocket for obs-studio package.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 22 Sep 2022 11:19:35 +0200

obs-studio-dmo (1:28.0.1-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 03 Sep 2022 08:47:42 +0200

obs-studio-dmo (1:28.0.0-dmo2) unstable; urgency=medium

  * Add enc-amf and obs-websocket plugins. aja plugins was built in the
    previous package.
      - aja : I/O device capture and output for AJA hardware.
      - enc-amf : AMD GPU encoder.
      - obs-websocket : computer communications protocol.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 02 Sep 2022 15:01:04 +0200

obs-studio-dmo (1:28.0.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 01 Sep 2022 07:28:16 +0200

obs-studio-dmo (1:27.2.4-dmo3) unstable; urgency=medium

  * Enable lua for powerpc
  * Build with ffmpeg 5.0

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 23 Jun 2022 15:20:03 +0200

obs-studio-dmo (1:27.2.4-dmo2) unstable; urgency=medium

  * Build with libluajit2-5.1-2

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 07 Jun 2022 14:18:01 +0200

obs-studio-dmo (1:27.2.4-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 29 Mar 2022 10:56:54 +0200

obs-studio-dmo (1:27.2.3-dmo2) unstable; urgency=medium

  * Build with python 3.10
  * Build with libftl0 instead of included ftl sdk.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 28 Mar 2022 10:49:37 +0200

obs-studio-dmo (1:27.2.3-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 05 Mar 2022 18:06:30 +0100

obs-studio-dmo (1:27.2.2-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 02 Mar 2022 00:54:11 +0100

obs-studio-dmo (1:27.2.1-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 21 Feb 2022 08:36:45 +0100

obs-studio-dmo (1:27.2.0-dmo2) unstable; urgency=medium

  * Build with mbedtls 2.28

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 17 Feb 2022 08:18:25 +0100

obs-studio-dmo (1:27.2.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 13 Feb 2022 08:59:59 +0100

obs-studio-dmo (1:27.1.3-dmo2) unstable; urgency=medium

  * Add Python 3.10 as supported version.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 20 Nov 2021 11:12:58 +0100

obs-studio-dmo (1:27.1.3-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 05 Oct 2021 01:21:07 +0200

obs-studio-dmo (1:27.1.2-dmo1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 04 Oct 2021 19:08:14 +0200

obs-studio-dmo (1:27.1.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 28 Sep 2021 14:20:19 +0200

=== debian/control ===
Source: obs-studio-dmo
Section: video
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://obsproject.com
Rules-Requires-Root: no
Standards-Version: 4.6.2
Build-Depends: debhelper-compat (= 13), dh-sequence-python3, cmake, quilt,
 libasound2-dev, libavfilter-dev, libv4l-dev, libx11-dev, libfreetype-dev,
 libcurl4-gnutls-dev | libcurl-dev, libdbus-1-dev, libfontconfig-dev,
 libqt5x11extras5-dev, libopengl-dev, libjack-jackd2-dev, swig, pkgconf,
 libjansson-dev (>= 2.5), libpulse-dev, libspeexdsp-dev, libxcb-xinerama0-dev,
 libudev-dev [linux-any], libx264-dev, libxcb-shm0-dev, qtbase5-dev, libftl-dev,
 libxcomposite-dev, libxinerama-dev, libvlc-dev, libx11-xcb-dev, libsimde-dev,
 python3-docutils (>= 0.6), libfdk-aac-dev, liblua5.2-dev, python3-dev,
 libmbedtls-dev, libfdk-aac-dev, libqt5svg5-dev, libxcb-xinput-dev, libasio-dev,
 libxcb-randr0-dev, libavdevice-dev, ninja-build, libpipewire-0.3-dev,
 libwayland-dev, qtbase5-private-dev, libdrm-dev, libluajit2-5.1-dev, libpci-dev,
 libxcb-composite0-dev, nv-codec-headers [amd64 arm64 i386], libxcb-dri2-0-dev,
 libxcb-glx0-dev, libxcb-keysyms1-dev, libxcb-sync-dev, libxcb-xv0-dev,
 libsrt-openssl-dev, libajantv2-dev [amd64], librist-dev, libva-dev,
 libwebsocketpp-dev, nlohmann-json3-dev

Package: obs-studio
Architecture: any
Depends: obs-plugins (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Suggests: libnvidia-encode1, pkexec | policykit-1
Replaces: obs-plugins (<= 1:26.0.0-dmo1), obs-websocket
Breaks: obs-plugins (<= 1:26.0.0-dmo1), obs-websocket
Description: recorder and streamer for live video content
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 Other features include:
  * Encoding using H264 (x264) and AAC
  * Unlimited number of scenes and sources
  * File output to MP4 or FLV
  * GPU-based game capture for high performance game streaming
  * Bilinear or lanczos3 resampling
 .
 Note that OBS Studio requires an OpenGL 3.2 compatible video card.

Package: obs-plugins
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Replaces: obs-studio
Recommends: vlc
Description: recorder and streamer for live video content (plugins)
 OBS is designed for efficiently recording and streaming live video content. It
 supports live RTP streaming to various streaming sites.
 .
 This package contains the plugins.

Package: libobs0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: recorder and streamer for live video content (shared library)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the shared library libobs.

Package: libobs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libobs0 (= ${binary:Version}), ${misc:Depends}, libsimde-dev
Description: recorder and streamer for live video content (development files)
 OBS Studio is designed for efficiently recording and streaming live video
 content. It supports live RTP streaming to various streaming sites.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

UPSTREAM_VERSION := $(shell echo $(DEB_VERSION) | sed -r 's/[^:]+://; s/-[^-]+$$//')

ifeq "$(DEB_BUILD_ARCH)" "arm64"
	confflags += -DENABLE_AJA=FALSE
endif

%:
	dh $@ -Scmake+ninja --with quilt

override_dh_auto_configure:
# git clone https://github.com/obsproject/obs-amd-encoder.git
# git checkout 8823c23
	ln -s ../obs-amd-encoder-2023-03-27-8823c23 plugins/enc-amf
# git clone https://github.com/obsproject/obs-websocket.git
# git checkout 57a9c19
# git submodule update --init --recursive
	ln -s ../obs-websocket-2023-05-02-57a9c19 plugins/obs-websocket

	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCPACK_RESOURCE_FILE_LICENSE=/usr/share/common-licenses/GPL-2 \
	-DDISABLE_UPDATE_MODULE=TRUE \
	-DENABLE_BROWSER=OFF \
	-DENABLE_JACK=TRUE \
	-DENABLE_LIBFDK=TRUE \
	-DENABLE_SNDIO=OFF \
	-DQT_VERSION=5 \
	-DISABLE_UPDATE_MODULE=TRUE \
	-DOBS_LIBRARY_DESTINATION=lib/$(DEB_HOST_MULTIARCH) \
	-DOBS_MULTIARCH_SUFFIX=/$(DEB_HOST_MULTIARCH) \
	-DOBS_VERSION_OVERRIDE=$(UPSTREAM_VERSION) \
	-DAPPDATA_RELEASE_DATE=$(shell date --utc --date=@$${SOURCE_DATE_EPOCH} +'%Y-%m-%d') \
	-DUNIX_STRUCTURE=TRUE \
	$(confflags) \
	-Wno-dev

#	exit 1

override_dh_auto_build:
	dh_auto_build

	rst2man debian/obs.rst > debian/obs.1

override_dh_install:
	rm debian/tmp/usr/share/obs/obs-plugins/decklink-captions/.keepme

	dh_install

	rm -rf debian/obs-studio/usr/share/obs/obs-studio/license

execute_after_dh_auto_install:
	chmod 644 debian/tmp/usr/share/obs/obs-studio/OBSPublicRSAKey.pem

override_dh_python3:
	dh_python3 -pobs-plugins usr/share/obs/obs-plugins/frontend-tools/scripts
	dh_python3 -pobs-plugins usr/lib/$(DEB_HOST_MULTIARCH)/obs-scripting

override_dh_clean:
	dh_clean debian/obs.1 cmake/.CMakeBuildNumber \
	obs-websocket-*/src/plugin-macros.generated.h

	-rm -rf plugins/obs-websocket
	-rm -rf plugins/enc-amf

override_dh_auto_test:

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%obs-studio-$1.tar.gz%,dversionmangle=s%\+dfsg\d*$%%,repacksuffix=+dfsg1" \
https://github.com/jp9000/obs-studio/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
